/*!
ng2-dynamic-forms 1.3.13 2017-02-12 13:40 UTC
Copyright (c) 2016, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ng2-dynamic-forms/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@ng2-dynamic-forms/core', '@angular/common'], factory) :
    (factory((global.ng2DF = global.ng2DF || {}, global.ng2DF.uiFoundation = global.ng2DF.uiFoundation || {}),global.ng.core,global.ng.forms,global.ng2DF.core,global.ng.common));
}(this, (function (exports,_angular_core,_angular_forms,_ng2DynamicForms_core,_angular_common) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var DYNAMIC_FORM_UI_FOUNDATION_SITES = "FOUNDATION_SITES";
exports.DynamicFormFoundationSitesComponent = (function (_super) {
    __extends(DynamicFormFoundationSitesComponent, _super);
    function DynamicFormFoundationSitesComponent(relationService) {
        var _this = _super.call(this, relationService) || this;
        _this.bindId = true;
        _this.hasErrorMessaging = false;
        _this.blur = new _angular_core.EventEmitter();
        _this.change = new _angular_core.EventEmitter();
        _this.focus = new _angular_core.EventEmitter();
        _this.type = DYNAMIC_FORM_UI_FOUNDATION_SITES;
        return _this;
    }
    return DynamicFormFoundationSitesComponent;
}(_ng2DynamicForms_core.DynamicFormControlComponent));
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Boolean)
], exports.DynamicFormFoundationSitesComponent.prototype, "bindId", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", _angular_forms.FormGroup)
], exports.DynamicFormFoundationSitesComponent.prototype, "controlGroup", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Boolean)
], exports.DynamicFormFoundationSitesComponent.prototype, "hasErrorMessaging", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", _ng2DynamicForms_core.DynamicFormControlModel)
], exports.DynamicFormFoundationSitesComponent.prototype, "model", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", _angular_core.QueryList)
], exports.DynamicFormFoundationSitesComponent.prototype, "nestedTemplates", void 0);
__decorate([
    _angular_core.Output(),
    __metadata("design:type", _angular_core.EventEmitter)
], exports.DynamicFormFoundationSitesComponent.prototype, "blur", void 0);
__decorate([
    _angular_core.Output(),
    __metadata("design:type", _angular_core.EventEmitter)
], exports.DynamicFormFoundationSitesComponent.prototype, "change", void 0);
__decorate([
    _angular_core.Output(),
    __metadata("design:type", _angular_core.EventEmitter)
], exports.DynamicFormFoundationSitesComponent.prototype, "focus", void 0);
__decorate([
    _angular_core.ContentChildren(_ng2DynamicForms_core.DynamicTemplateDirective),
    __metadata("design:type", _angular_core.QueryList)
], exports.DynamicFormFoundationSitesComponent.prototype, "templates", void 0);
exports.DynamicFormFoundationSitesComponent = __decorate([
    _angular_core.Component({
        selector: "dynamic-form-foundation-sites-control",
        template: "<div [formGroup]=\"controlGroup\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\"><div *ngIf=\"formControlType !== 2 && model.label !== null\" [ngClass]=\"model.cls.grid.label\"><label [attr.for]=\"model.id\" [class.is-invalid-label]=\"hasErrorMessaging && !hasFocus && isInvalid\" [innerHTML]=\"model.label\" [ngClass]=\"model.cls.element.label\"></label></div><template *ngIf=\"hasStartTemplate && formControlType !== 1\" [ngTemplateOutlet]=\"template\" [ngOutletContext]=\"model\"></template><div [ngClass]=\"model.cls.grid.control\"><ng-container [ngSwitch]=\"formControlType\"><div *ngSwitchCase=\"1\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><fieldset *ngFor=\"let groupModel of model.groups; let idx = index\" [formGroupName]=\"idx\"><dynamic-form-foundation-sites-control *ngFor=\"let controlModel of groupModel.group\" [bindId]=\"false\" [controlGroup]=\"control.at(idx)\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [nestedTemplates]=\"templates\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-form-foundation-sites-control><template [ngTemplateOutlet]=\"template\" [ngOutletContext]=\"groupModel\"></template></fieldset></div><label *ngSwitchCase=\"2\"><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [value]=\"model.value\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><span [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\" [innerHTML]=\"model.label\"></span></label><fieldset *ngSwitchCase=\"3\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><dynamic-form-foundation-sites-control *ngFor=\"let controlModel of model.group\" [controlGroup]=\"control\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [nestedTemplates]=\"templates\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-form-foundation-sites-control></fieldset><div *ngSwitchCase=\"4\" class=\"input-group\"><span *ngIf=\"model.prefix\" class=\"input-group-label\" [innerHTML]=\"model.prefix\"></span> <input class=\"input-group-field\" [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [class.is-invalid-input]=\"hasErrorMessaging && !hasFocus && isInvalid\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"> <span *ngIf=\"model.suffix\" class=\"input-group-label\" [innerHTML]=\"model.suffix\"></span><datalist *ngIf=\"model.list\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"5\" role=\"radiogroup\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [name]=\"model.name\" (change)=\"onValueChange($event)\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><label *ngFor=\"let option of model.options\"><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [value]=\"option.value\" (blur)=\"onFocusChange($event)\" (focus)=\"onFocusChange($event)\"><span [innerHTML]=\"option.label\"></span></label></fieldset><select *ngSwitchCase=\"6\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><option *ngFor=\"let option of model.options\" [attr.name]=\"model.name\" [ngValue]=\"option.value\">{{option.label}}</option></select><div *ngSwitchCase=\"7\" class=\"switch\" [ngClass]=\"model.cls.element.control\"><input type=\"checkbox\" class=\"switch-input\" [attr.tabindex]=\"model.tabIndex\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [required]=\"model.required\" [value]=\"model.value\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><label class=\"switch-paddle\" [attr.for]=\"model.id\"><span class=\"switch-active\" aria-hidden=\"true\">{{model.onLabel}}</span> <span class=\"switch-inactive\" aria-hidden=\"true\">{{model.offLabel}}</span></label></div><textarea *ngSwitchCase=\"8\" [attr.tabindex]=\"model.tabIndex\" [class.is-invalid-input]=\"hasErrorMessaging && !hasFocus && isInvalid\" [cols]=\"model.cols\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></textarea></ng-container><p *ngIf=\"hasHint\" class=\"help-text\" [ngClass]=\"model.cls.element.hint\" [innerHTML]=\"model.hint\"></p></div><ul *ngIf=\"hasErrorMessaging\" [ngClass]=\"[model.cls.element.errors, model.cls.grid.errors]\"><li *ngFor=\"let message of errorMessages\" class=\"form-error\" [class.is-visible]=\"showErrorMessages\">{{message}}</li></ul><template *ngIf=\"hasEndTemplate && formControlType !== 1\" [ngTemplateOutlet]=\"template\" [ngOutletContext]=\"model\"></template><ng-content></ng-content></div>"
    }),
    __metadata("design:paramtypes", [_ng2DynamicForms_core.DynamicFormRelationService])
], exports.DynamicFormFoundationSitesComponent);

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.DynamicFormsFoundationUIModule = (function () {
    function DynamicFormsFoundationUIModule() {
    }
    return DynamicFormsFoundationUIModule;
}());
exports.DynamicFormsFoundationUIModule = __decorate$1([
    _angular_core.NgModule({
        imports: [
            _angular_common.CommonModule,
            _angular_forms.ReactiveFormsModule,
            _ng2DynamicForms_core.DynamicFormsCoreModule
        ],
        declarations: [
            exports.DynamicFormFoundationSitesComponent
        ],
        exports: [
            _ng2DynamicForms_core.DynamicFormsCoreModule,
            exports.DynamicFormFoundationSitesComponent
        ]
    })
], exports.DynamicFormsFoundationUIModule);

exports.DYNAMIC_FORM_UI_FOUNDATION_SITES = DYNAMIC_FORM_UI_FOUNDATION_SITES;

Object.defineProperty(exports, '__esModule', { value: true });

})));
